/**
 * This class was generated from a set of XML constraints
 *   by the Enhydra Zeus XML Data Binding Framework. All
 *   source code in this file is constructed specifically
 *   to work with other Zeus-generated classes. If you
 *   modify this file by hand, you run the risk of breaking
 *   this interoperation, as well as introducing errors in
 *   source code compilation.
 *
 * * * * * MODIFY THIS FILE AT YOUR OWN RISK * * * * *
 *
 * To find out more about the Enhydra Zeus framework, you
 *   can point your browser at <http://zeus.enhydra.org>
 *   where you can download releases, join and discuss Zeus
 *   on user and developer mailing lists, and access source
 *   code. Please report any bugs through that website.
 */
package org.objectweb.jonas_ejb.deployment.xml;

// Global Implementation Import Statements
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Reader;
import java.io.Writer;
import org.xml.sax.Attributes;
import org.xml.sax.EntityResolver;
import org.xml.sax.ErrorHandler;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.helpers.XMLReaderFactory;

// Local Implementation Import Statements
import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;

public class AssemblyDescriptorImpl extends DefaultHandler implements Unmarshallable, AssemblyDescriptor {

    private List securityRoleList;
    private List methodPermissionList;
    private List containerTransactionList;
    private ExcludeList excludeList;
    private String id;
    private boolean zeus_idSet;

    /** The current node in unmarshalling */
    private Unmarshallable zeus_currentUNode;

    /** The parent node in unmarshalling */
    private Unmarshallable zeus_parentUNode;

    /** Whether this node has been handled */
    private boolean zeus_thisNodeHandled = false;

    /** The EntityResolver for SAX parsing to use */
    private static EntityResolver entityResolver;

    /** The ErrorHandler for SAX parsing to use */
    private static ErrorHandler errorHandler;

    public AssemblyDescriptorImpl() {
        securityRoleList = new LinkedList();
        methodPermissionList = new LinkedList();
        containerTransactionList = new LinkedList();
        zeus_idSet = false;
    }

    public List getSecurityRoleList() {
        return securityRoleList;
    }

    public void setSecurityRoleList(List securityRoleList) {
        this.securityRoleList = securityRoleList;
    }

    public void addSecurityRole(SecurityRole securityRole) {
        securityRoleList.add(securityRole);
    }

    public void removeSecurityRole(SecurityRole securityRole) {
        securityRoleList.remove(securityRole);
    }

    public List getMethodPermissionList() {
        return methodPermissionList;
    }

    public void setMethodPermissionList(List methodPermissionList) {
        this.methodPermissionList = methodPermissionList;
    }

    public void addMethodPermission(MethodPermission methodPermission) {
        methodPermissionList.add(methodPermission);
    }

    public void removeMethodPermission(MethodPermission methodPermission) {
        methodPermissionList.remove(methodPermission);
    }

    public List getContainerTransactionList() {
        return containerTransactionList;
    }

    public void setContainerTransactionList(List containerTransactionList) {
        this.containerTransactionList = containerTransactionList;
    }

    public void addContainerTransaction(ContainerTransaction containerTransaction) {
        containerTransactionList.add(containerTransaction);
    }

    public void removeContainerTransaction(ContainerTransaction containerTransaction) {
        containerTransactionList.remove(containerTransaction);
    }

    public ExcludeList getExcludeList() {
        return excludeList;
    }

    public void setExcludeList(ExcludeList excludeList) {
        this.excludeList = excludeList;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
        zeus_idSet = true;
    }

    public void marshal(File file) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new FileWriter(file));
    }

    public void marshal(OutputStream outputStream) throws IOException {
        // Delegate to the marshal(Writer) method
        marshal(new OutputStreamWriter(outputStream));
    }

    public void marshal(Writer writer) throws IOException {
        // Write out the XML declaration
        writer.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n\n");

        // Now start the recursive writing
        writeXMLRepresentation(writer, "");

        // Close up
        writer.flush();
        writer.close();
    }

    protected void writeXMLRepresentation(Writer writer,
                                          String indent)
        throws IOException {

        writer.write(indent);
        writer.write("<assembly-descriptor");

        // Handle attributes (if needed)
        if (zeus_idSet) {
            writer.write(" id=\"");
            writer.write(escapeAttributeValue(id));
            writer.write("\"");
        }
        writer.write(">");
        writer.write("\n");

        // Handle child elements
        for (Iterator i=securityRoleList.iterator(); i.hasNext(); ) {
            SecurityRoleImpl securityRole = (SecurityRoleImpl)i.next();
            securityRole.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        for (Iterator i=methodPermissionList.iterator(); i.hasNext(); ) {
            MethodPermissionImpl methodPermission = (MethodPermissionImpl)i.next();
            methodPermission.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        for (Iterator i=containerTransactionList.iterator(); i.hasNext(); ) {
            ContainerTransactionImpl containerTransaction = (ContainerTransactionImpl)i.next();
            containerTransaction.writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }
        if (excludeList != null) {
            ((ExcludeListImpl)excludeList).writeXMLRepresentation(writer,
                new StringBuffer(indent).append("  ").toString());
        }

        writer.write(indent);
        writer.write("</assembly-descriptor>\n");
    }

    private String escapeAttributeValue(String attributeValue) {
        String returnValue = attributeValue;
        for (int i = 0; i < returnValue.length(); i++) {
            char ch = returnValue.charAt(i);
            if (ch == '"') {
                returnValue = new StringBuffer()
                    .append(returnValue.substring(0, i))
                    .append("&quot;")
                    .append(returnValue.substring(i+1))
                    .toString();
            }
        }
        return returnValue;
    }

    /**
     * <p>
     *  This sets a SAX <code>EntityResolver</code> for this unmarshalling process.
     * </p>
     *
     * @param resolver the entity resolver to use.
     */
    public static void setEntityResolver(EntityResolver resolver) {
        entityResolver = resolver;
    }

    /**
     * <p>
     *  This sets a SAX <code>ErrorHandler</code> for this unmarshalling process.
     * </p>
     *
     * @param handler the entity resolver to use.
     */
    public static void setErrorHandler(ErrorHandler handler) {
        errorHandler = handler;
    }

    public static AssemblyDescriptor unmarshal(File file) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file));
    }

    public static AssemblyDescriptor unmarshal(File file, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new FileReader(file), validate);
    }

    public static AssemblyDescriptor unmarshal(InputStream inputStream) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream));
    }

    public static AssemblyDescriptor unmarshal(InputStream inputStream, boolean validate) throws IOException {
        // Delegate to the unmarshal(Reader) method
        return unmarshal(new InputStreamReader(inputStream), validate);
    }

    public static AssemblyDescriptor unmarshal(Reader reader) throws IOException {
        // Delegate with default validation value
        return unmarshal(reader, false);
    }

    public static AssemblyDescriptor unmarshal(Reader reader, boolean validate) throws IOException {
        AssemblyDescriptorImpl assemblyDescriptor = new AssemblyDescriptorImpl();
        assemblyDescriptor.setCurrentUNode(assemblyDescriptor);
        assemblyDescriptor.setParentUNode(null);
        // Load the XML parser
        XMLReader parser = null;
        String parserClass = System.getProperty("org.xml.sax.driver",
            "org.apache.xerces.parsers.SAXParser");
        try {
            parser = XMLReaderFactory.createXMLReader(parserClass);

            // Set entity resolver, if needed
            if (entityResolver != null) {
                parser.setEntityResolver(entityResolver);
            }

            // Set error handler, if needed
            if (errorHandler != null) {
                parser.setErrorHandler(errorHandler);
            }

            // Register content handler
            parser.setContentHandler(assemblyDescriptor);
        } catch (SAXException e) {
            throw new IOException("Could not load XML parser: " + 
                e.getMessage());
        }

        InputSource inputSource = new InputSource(reader);
        try {
            parser.setFeature("http://xml.org/sax/features/validation", new Boolean(validate).booleanValue());
            parser.parse(inputSource);
        } catch (SAXException e) {
            throw new IOException("Error parsing XML document: " + 
                e.getMessage());
        }

        // Return the resultant object
        return assemblyDescriptor;
    }

    public Unmarshallable getParentUNode() {
        return zeus_parentUNode;
    }

    public void setParentUNode(Unmarshallable parentUNode) {
        this.zeus_parentUNode = parentUNode;
    }

    public Unmarshallable getCurrentUNode() {
        return zeus_currentUNode;
    }

    public void setCurrentUNode(Unmarshallable currentUNode) {
        this.zeus_currentUNode = currentUNode;
    }

    public void startElement(String namespaceURI, String localName,
                             String qName, Attributes atts)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.startElement(namespaceURI, localName, qName, atts);
            return;
        }

        // See if we handle, or we delegate
        if ((localName.equals("assembly-descriptor")) && (!zeus_thisNodeHandled)) {
            // Handle ourselves
            for (int i=0, len=atts.getLength(); i<len; i++) {
                String attName= atts.getLocalName(i);
                String attValue = atts.getValue(i);
                if (attName.equals("id")) {
                    setId(attValue);
                }
            }
            zeus_thisNodeHandled = true;
            return;
        } else {
            // Delegate handling
            if (localName.equals("security-role")) {
                SecurityRoleImpl securityRole = new SecurityRoleImpl();
                current = getCurrentUNode();
                securityRole.setParentUNode(current);
                securityRole.setCurrentUNode(securityRole);
                this.setCurrentUNode(securityRole);
                securityRole.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                securityRoleList.add(securityRole);
                return;
            }
            if (localName.equals("method-permission")) {
                MethodPermissionImpl methodPermission = new MethodPermissionImpl();
                current = getCurrentUNode();
                methodPermission.setParentUNode(current);
                methodPermission.setCurrentUNode(methodPermission);
                this.setCurrentUNode(methodPermission);
                methodPermission.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                methodPermissionList.add(methodPermission);
                return;
            }
            if (localName.equals("container-transaction")) {
                ContainerTransactionImpl containerTransaction = new ContainerTransactionImpl();
                current = getCurrentUNode();
                containerTransaction.setParentUNode(current);
                containerTransaction.setCurrentUNode(containerTransaction);
                this.setCurrentUNode(containerTransaction);
                containerTransaction.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                containerTransactionList.add(containerTransaction);
                return;
            }
            if (localName.equals("exclude-list")) {
                ExcludeListImpl excludeList = new ExcludeListImpl();
                current = getCurrentUNode();
                excludeList.setParentUNode(current);
                excludeList.setCurrentUNode(excludeList);
                this.setCurrentUNode(excludeList);
                excludeList.startElement(namespaceURI, localName, qName, atts);
                // Add this value in
                this.excludeList = excludeList;
                return;
            }
        }
    }

    public void endElement(String namespaceURI, String localName,
                           String qName)
        throws SAXException {

        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.endElement(namespaceURI, localName, qName);
            return;
        }

        Unmarshallable parent = getCurrentUNode().getParentUNode();
        if (parent != null) {
            parent.setCurrentUNode(parent);
        }
    }

    public void characters(char[] ch, int start, int len)
        throws SAXException {

        // Feed this to the correct ContentHandler
        Unmarshallable current = getCurrentUNode();
        if (current != this) {
            current.characters(ch, start, len);
            return;
        }

        String text = new String(ch, start, len);
        text = text.trim();
    }

}
